<?php
// $Id: drupalvb.inc.php,v 1.9 2008/04/19 02:58:47 sun Exp $


// Enter YOUR license number for cookies.
define('VB_LICENSE', 'VB--------');

// drupalvb_msg() message type defines.
define('DVBERROR', 'error', TRUE);
define('DVBLOGIN', 'login', TRUE);
define('DVBLOGOUT', 'logout', TRUE);
define('DVBREGISTER', 'register', TRUE);

// Version info.
define('DVB_DRUPAL_VER', '5.x', TRUE);
define('DVB_VER', '1.0', TRUE);

/**
 * Connect to the vB database.
 */
function drupalvb_connect_db() {
  $vblink = mysql_connect(VB_SERVER, VB_USER, VB_PASS);
  if (!$vblink) {
    die('Could not connect: '. mysql_error());
  }
  $vb_db_select = mysql_select_db(VB_DATABASE, $vblink);
  if (!$vb_db_select) {
    die('Cannot select database . '. VB_DATABASE .': '. mysql_error());
  }
  return $vblink;
}

/**
 * Initialize a vBulletin object.
 */
function _drupalvb_vb_init($class = FALSE, $config = TRUE, $options = TRUE) {
  if ($class) {
    $vbulletin = new vB_Registry();
  }
  if ($config) {
    $vbulletin->config = _drupalvb_fetch_config();
  }
  if ($options) {
    $vbulletin->options = _drupalvb_get_options();
  }
  return $vbulletin;
}

/**
 * Close the link to the vB database.
 */
function drupalvb_close($vblink) {
  mysql_close($vblink);
}

/**
 * Grab the configuration/options of the vB installation.
 */
function _drupalvb_fetch_config() {
  static $config = array();

  $config_file = drupal_get_path('module', 'drupalvb') .'/config.php';
  if (empty($config) && file_exists($config_file)) {
    require_once $config_file;
  }
  return $config;
}

/**
 * Parse (if necessary) and display appropriate drupalvb messages.
 */
function drupalvb_msg($msg, $arg = 'unknown') {
  switch ($msg) {
    case DVBERROR:
      drupal_set_message('Error: '. $arg);
      break;

    default:
      drupal_set_message($arg);
  }
  return;
}

/**
 * Set the necessary cookies for the user to be logged into the forum.
 */
function _drupalvb_set_login_cookies($userid, $password) {
  $vbulletin = _drupalvb_vb_init();

  $cookie_prefix = (empty($vbulletin->config['Misc']['cookieprefix']) ? 'bb' :
    $vbulletin->config['Misc']['cookieprefix']
  );
  $cookie_path = $vbulletin->options['cookiepath'];
  $cookie_domain = $vbulletin->options['cookiedomain'];

  $expire = time() + 60 * 60 * 24 * 365;
  setcookie($cookie_prefix .'sessionhash', md5('drupalvb'. $userid), $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'lastvisit', time(), $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'lastactivity', '0', $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'userid', $userid, $expire, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'password', md5($password . VB_LICENSE), $expire, $cookie_path, $cookie_domain);

  return;
}

/**
 * Clear any database cookies.
 */
function _drupalvb_clear_cookies() {
  $vbulletin = _drupalvb_vb_init();

  $cookie_prefix = (empty($vbulletin->config['Misc']['cookieprefix']) ? 'bb' : $vbulletin->config['Misc']['cookieprefix']);
  $cookie_path = $vbulletin->options['cookiepath'];
  $cookie_domain = $vbulletin->options['cookiedomain'];

  // Clear our login cookies beginning.
  setcookie($cookie_prefix .'sessionhash', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'lastvisit', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'lastactivity', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'userid', '', 1, $cookie_path, $cookie_domain);
  setcookie($cookie_prefix .'password', '', 1, $cookie_path, $cookie_domain);

  return;
}

/**
 * Create an entry in the vB database user table.
 */
function _drupalvb_create_vb_user($username, $password, $email, $silent = FALSE) {
  // Double check to make sure we're not duplicating an entry.
  $result = db_query(_drupalvb_prefix("SELECT userid FROM {user} WHERE username = '%s'", $username));

  if (db_fetch_array($result)) {
    // The user existed somehow, so send the error and kick it out with a fail.
    // Skip pre-existing users without a message when exporting users from
    // Drupal to vBulletin.
    if (!$silent) {
      drupalvb_msg(DVBERROR, 'Your username already existed on the forums. The duplication problem has been logged. If this error message continues to display, please contact the site administrator.');
      watchdog('drupalvb', 'Attempted to create a duplicate vB user.', WATCHDOG_ERROR);
    }
    return false;
  }

  // Set up the necessary variables.
  $salt = '';
  for ($i = 0; $i < 3; $i++) {
    $salt .= chr(rand(32, 126));
  }

  // This hack expects users to not have 32 character length passwords.
  if (strlen($password) != 32) {
    $password = md5($password);
  }

  $passhash = md5($password . $salt);
  $passdate = date('Y-m-d H:i:s', time());
  $joindate = time();

  // Attempt to grab the user title from the database.
  $result = db_query(_drupalvb_prefix("SELECT title FROM {usertitle} WHERE minposts = 0"));

  if ($resarray = db_fetch_array($result)) {
    $usertitle = $resarray['title'];
  }
  else {
    $usertitle = 'Junior Member';
  }

  // Grab the default timezone offset, divided by 3600 b/c the system.module
  // timezone form is in seconds.
  $timezone = variable_get('drupalvb_default_timezone', '-18000');
  $timezone = intval($timezone) / 3600;

  // Default new user options: I got these by setting up a new user how I
  // wanted and looking in the database to see what options were set for him.
  $options = variable_get('drupalvb_default_options', '3415');

  // Default usergroup id.
  $usergroupid = variable_get('drupalvb_default_usergroup', '2');

  // Set up the insertion query.
  $result = db_query(_drupalvb_prefix("INSERT INTO {user} (username, usergroupid, password, passworddate, usertitle, email, salt, showvbcode, languageid, timezoneoffset, posts, joindate, lastvisit, lastactivity, options) VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', 1, 1, '%s', 0, '%s', '%s', '%s', '%s')"), $username, $usergroupid, $passhash, $passdate, $usertitle, $email, $salt, $timezone, $joindate, $joindate, $joindate, $options);

  $userid = mysql_insert_id();

  db_query(_drupalvb_prefix("INSERT INTO {userfield} VALUES (%d, NULL, '', '', '', '')"), $userid);
  db_query(_drupalvb_prefix("INSERT INTO {usertextfield} VALUES (%d, NULL, NULL, NULL, NULL, '', NULL, NULL)"), $userid);

  // Return true if the vB user was created successfully.
  return true;
}

/**
 * Update an entry in the vB database user table.
 */
function _drupalvb_update_vb_user($username, $password, $email, $salt) {
  // Set up the necessary variables.
  $lastdate = time();
  $setpass = '';

  if ($password != '') {
    // This hack expects users to not have 32 character length passwords.
    if (strlen($password) != 32) {
      $password = md5($password);
    }
    $passhash = md5($password . $salt);
    $passdate = date('Y-m-d H:i:s', time());
    db_query(_drupalvb_prefix("UPDATE {user} SET password = '%s', passworddate = '%s', salt = '%s', email = '%s', lastactivity = '%s' WHERE username = '%s'"), $passhash, $passdate, $salt, $email, $lastdate, $username);
  }
  else {
    db_query(_drupalvb_prefix("UPDATE {user} SET email = '%s', lastactivity = '%s' WHERE username = '%s'"), $email, $lastdate, $username);
  }

  return;
}

/**
 * Count the number of users online, guests and members.
 */
function _drupalvb_get_users() {
  $vbulletin = _drupalvb_vb_init();

  $datecut          = time() - $vbulletin->options['cookietimeout'];
  $numbervisible    = 0;
  $numberregistered = 0;
  $numberguest      = 0;

  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
  }

  $result = db_query(_drupalvb_prefix("SELECT user.username, user.usergroupid, session.userid, session.lastactivity FROM {session} AS session LEFT JOIN {user} AS user ON (user.userid = session.userid) WHERE session.lastactivity > %d"), $datecut);

  $userinfos = array();

  while ($loggedin = db_fetch_array($result)) {
    $userid = $loggedin['userid'];
    if (!$userid) {
      $numberguest++;
    }
    else if (empty($userinfos[$userid]) || ($userinfos[$userid]['lastactivity'] < $loggedin['lastactivity'])) {
      $userinfos[$userid] = $loggedin;
    }
  }
  foreach ($userinfos as $userid => $loggedin) {
    $numberregistered++;
  }
  unset($userinfos);

  db_set_active('default');

  return array('guests' => $numberguest, 'members' => $numberregistered);
}

/**
 * Grab the number of new or recent posts for a user.
 */
function _drupalvb_get_posts($scope = 'last') {
  global $user;

  // Queries the vB user database to find a matching set of user data.
  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
  }

  $result = db_query(_drupalvb_prefix("SELECT userid, username, lastvisit FROM {user} WHERE username = '%s'"), $user->name);

  // Make sure a user is logged in to get their last visit and appropriate post
  // count.
  if ($vb_user = db_fetch_array($result)) {
    if ($scope == 'last') {
      $datecut = $vb_user['lastvisit'];
    }
    else if ($scope == 'daily') {
      $datecut = time() - 86400;
    }
    $result = db_query(_drupalvb_prefix("SELECT postid FROM {post} WHERE dateline > %d"), $datecut);
    $posts = db_num_rows($result);
  }
  else {
    $posts = 0;
  }

  db_set_active('default');

  return $posts;
}

/**
 * Grab the usergroup names/ids from the database.
 */
function _drupalvb_get_usergroups() {
  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
    return array('Usergroups not found');
  }
  $result = db_query(_drupalvb_prefix("SELECT usergroupid, title FROM {usergroup}"));

  $usergroups = array();
  while ($data = db_fetch_object($result)) {
    $usergroups[$data->usergroupid] = $data->title;
  }
  if (!$usergroups) {
    $usergroups[] = 'Usergroups not found';
  }

  db_set_active('default');

  return $usergroups;
}

/**
 * Get the vBulletin options.
 */
function _drupalvb_get_options() {
  if (!db_set_active('vbulletin')) {
    drupal_set_message('Refer to README.txt for database setup instructions.');
    return null;
  }
  $result = db_query(_drupalvb_prefix("SELECT data FROM {datastore} WHERE title = 'options'"));

  if ($data = db_fetch_object($result)) {
    $options = unserialize($data->data);
  }

  db_set_active('default');

  return $options;
}

/**
 * Prefix database tables in a SQL query.
 */
function _drupalvb_prefix($sql) {
  $vbulletin = _drupalvb_vb_init(FALSE, TRUE, FALSE);
  return strtr($sql, array('{' => $vbulletin->config['Database']['tableprefix'], '}' => ''));
}

